   --      LibGrp_1.hs
   --      
   -----------------------------------------                        
   import LibGrp_1                                                     
                                                                       
   test =   testAddArc && testListNode && testNeighb && testNeighb_1 
         && testDeleteNode && testAddList && testSrchNode 
         && testDelArc && testIstoks && testStoks 
         && testMemberList && testOneRange && testListSet 
         && testEqualSet && testStr2num 
   --------------------------------------------------- 
   testAddArc =   addArc "3" "4" []     == [("3","4")] 
               && addArc "3" "FALSE" [] == [("3","FALSE")]
               && addArc "3" "4" [("5","4"),("3","5"),("6","7")] 
                    == [("3","4"),("5","4"),("3","5"),("6","7")] 
               && addArc "3" "4"  [("5","4"),("3","4"),("6","7")] 
                    == [("5","4"),("3","4"),("6","7")] 
               && addArc "3" "FALSE" [("1","2"),("3","4")]
                    == [("1","2"),("3","4")] 
               && addArc "3" "4" [("1","2"),("3","4")]
                    == [("1","2"),("3","4")] 
               && addArc "3" "6" [("3","5"),("3","6")]
                    == [("3","5"),("3","6")] 
               && addArc "4" "3" (addArc "3" "4" [])
                    == [("4","3"),("3","4")] 
   -----------------------------------------------
   testListNode =   listNode [("3","2"),("3","4")]
                      == ["2","3","4"]
                 && listNode [("1","2"),("5","4")]
                      == ["1","2","5","4"]
                 && listNode [("1","2"),("3","4"),("5","6")]
                      == ["1","2","3","4","5","6"]
   ---------------------------------------------------------  
   testNeighb =   neighb "1" [("1","2"),("1","3"),("2","3"),           
                              ("5","FALSE")] == ["2","3"]
               && neighb "2" [("1","2"),("1","3"),("2","3"),           
                              ("5","FALSE")] == ["1","3"]            
               && neighb "3" [("1","2"),("1","3"),("2","3"),           
                              ("5","FALSE")] == ["1","2"]  
               && neighb "5" [("1","2"),("1","3"),("2","3"),           
                              ("5","FALSE")] == []
               && neighb "1" [("1","1")]     == ["1"]   
               && neighb "1" [("1","1"),("1","3")] 
                                              == ["1","3"] 
               && neighb "1" [("1","2"),("2","1"),("1","3"),
                              ("3","1"),("2","3"),("3","2"),
                              ("5","FALSE")] == ["2","2","3","3"] 
               && neighb "2" [("1","2"),("2","1"),("1","3"),
                              ("3","1"),("2","3"),("3","2"),
                              ("5","FALSE")] == ["1","1","3","3"]
   -------------------------------------------------------------- 
   testNeighb_1 =   neighb_1 "1" [("1","2"),("1","3"),("2","3"),       
                                  ("5","FALSE")] == ["2","3"]  
                 && neighb_1 "2" [("1","2"),("1","3"),("2","3"),       
                                  ("5","FALSE")] == ["3"] 
                 && neighb_1 "3" [("1","2"),("1","3"),("2","3"),       
                                  ("5","FALSE")] == []
                 && neighb_1 "5" [("1","2"),("1","3"),("2","3"),       
                                  ("5","FALSE")] == []
   -------------------------------------------------------               
   testDeleteNode =   deleteNode "2" [("3","1"),("3","2"),             
                                      ("2","4")] == [("3","1")]
                   && deleteNode "3" [("3","1"),("3","2"),             
                                    ("2","3")] == []
   -------------------------------------------------               
   testAddList =   addList "3" ["5","6","7"]                           
                           [("2","3"),("1","6"),("5","4")] 
                      == [("3","7"),("3","6"),("3","5"),("2","3"),             
                                              ("1","6"),("5","4")]
                && addList "3" ["5","6","7"] [("3","5"),("3","6")] 
                      == [("3","7"),("3","5"),("3","6")]
   -----------------------------------------------------
   testSrchNode =   srchNode ["2","3"] ["1","2","3","4"]               
                             [("4","2"),("2","1"),("4","3")] == "4"
                 && srchNode ["2","3"] ["1","2","3","4"]               
                             [("2","4"),("2","1"),("3","4")] == "4"
                 && srchNode ["2","3"] ["1","2","3","4"]               
                             [("4","2"),("2","1"),("3","4")] == "4"
                 && srchNode ["3","2"] ["1","2","3"]                   
                             [("3","2"),("2","1"),("3","1")] == "1" 
   ----------------------------------------------------------------  
   testDelArc =   delArc "3" "4" [("1","2"),("3","4"),("4","3")] 
                     == [("1","2"),("4","3")]
               && delArc "3" "4" [("3","4")] 
                     == [("3","FALSE"),("4","FALSE")]
               && delArc "3" "4" [("3","4"),("3","1")] 
                     == [("4","FALSE"),("3","1")]
               && delArc "2" "1" [("2","1"),("2","3"),("3","1")] 
                     == [("2","3"),("3","1")]  
               && delArc "2" "1" [("2","1"),("4","3"),("3","1")] 
                     == [("2","FALSE"),("4","3"),("3","1")]
               && delArc "2" "1" [("2","1"),("4","3"),("3","5")] 
                     == [("2","FALSE"),("1","FALSE"),("4","3"),
                                                     ("3","5")]
               && delArc "2" "1" [("2","1"),("2","3"),("3","4")]
                     == [("1","FALSE"),("2","3"),("3","4")]
               && delArc "2" "1" [("2","1")]
                     == [("2","FALSE"),("1","FALSE")]
               && delArc "3" "5" [("2","1"),("3","4")]
                     == [("2","1"),("3","4")]
               && delArc "2" "4" [("2","1"),("3","4")]
                     == [("2","1"),("3","4")]
               && delArc "2" "3" [("2","FALSE")] 
                     == [("2","FALSE")]
               && delArc "1" "3" [("1","FALSE"),("2","FALSE"),         
                                                ("3","FALSE")]
                     == [("1","FALSE"),("2","FALSE"),("3","FALSE")]
   ---------------------------------------------------------------- 
   testIstoks =   istoks [("1","2"),("3","4"),("4","3")]
                                               == ["1","3","4"]
               && istoks [("1","1"),("2","2")] == ["1","2"] 
   --------------------------------------------------------          
   testStoks =   stoks [("1","2"),("3","4"),("4","3")]
                                              == ["2","4","3"]
              && istoks [("1","1"),("2","2")] == ["1","2"]       
   --------------------------------------------------------         
   --    ( ):         
   -----------------------------------------------------------         
   testMemberList =   memberList ("3","2") [("1","2"),("3","2"),       
                                            ("1","4")] == True
                   && memberList ("3","2") [("2","3"),("3","3"),       
                                            ("3","2")] == True
   ----------------------------------------------------------- 
   testListSet = listSet ["1","1","1","1","2","2","2","2","3"] 
                                                   == ["1","2","3"]
   ---------------------------------------------------------------- 
   testOneRange =   oneRange [("1","2"),("4","5"),("2","1")]
                              == ["1","2","4","5","2","1"]
                 && oneRange [("1","2"),("1","2"),("1","2")] 
                              == ["1","2","1","2","1","2"]
   ------------------------------------------------------- 
   testEqualSet =   equalSet ["5","4","3","2","1"]                     
                             ["3","1","2","4","5"] == True 
                 && equalSet ["5","4","3","2","1"]                     
                             ["3","1","2","4"]     == False
   --------------------------------------------------------              
   testStr2num =   str2num "1"           == 1
                && str2num "-1"          == -1
                && str2num "12"          == 12
                && str2num "-12"         == -12
                && str2num "123456789"   == 123456789
                && str2num "-123456789"  == -123456789
                && str2num "2147483647"  == 2147483647
                && str2num "-2147483647" == -2147483647